

library(MASS)

logfpath.d2t2 <- "C:/Users/Graham/AAA/Programming/GoteborgSim/2012-10-17-nodata/dip2tet2/Zg1n1t1/Z4LOGg1n1t1r1.txt"
logfpath.d2t8 <- "C:/Users/Graham/AAA/Programming/GoteborgSim/2012-10-17-nodata/dip2tet8/Zg1n1t1/Z4LOGg1n1t1r1.txt"
logfpath.d8t2 <- "C:/Users/Graham/AAA/Programming/GoteborgSim/2012-10-17-nodata/dip8tet2/Zg1n1t1/Z4LOGg1n1t1r1.txt"
logfpath.d8t8 <- "C:/Users/Graham/AAA/Programming/GoteborgSim/2012-10-17-nodata/dip8tet8/Zg1n1t1/Z4LOGg1n1t1r1.txt"
x.d2t2 <- read.table(file=logfpath.d2t2, header=TRUE, skip=2)
x.d2t8 <- read.table(file=logfpath.d2t8, header=TRUE, skip=2)
x.d8t2 <- read.table(file=logfpath.d8t2, header=TRUE, skip=2)
x.d8t8 <- read.table(file=logfpath.d8t8, header=TRUE, skip=2)
xnh.d2t2 <- x.d2t2[,"NumHybs"]
xnh.d2t8 <- x.d2t8[,"NumHybs"]
xnh.d8t2 <- x.d8t2[,"NumHybs"]
xnh.d8t8 <- x.d8t8[,"NumHybs"]

counts.d2t2 <- rep(0,2)
counts.d2t8 <- rep(0,8)
counts.d8t2 <- rep(0,2)
counts.d8t8 <- rep(0,8)
for (i in 1:2) {
  counts.d2t2[i] <- length(which(xnh.d2t2==i))
  counts.d8t2[i] <- length(which(xnh.d8t2==i))
  }
for (i in 1:8) {
  counts.d2t8[i] <- length(which(xnh.d2t8==i)) 
  counts.d8t8[i] <- length(which(xnh.d8t8==i))
  }
densities.d2t2 <- counts.d2t2/sum(counts.d2t2)
densities.d2t8 <- counts.d2t8/sum(counts.d2t8)
densities.d8t2 <- counts.d8t2/sum(counts.d8t2)
densities.d8t8 <- counts.d8t8/sum(counts.d8t8)

drawgraphs <- function(xnh, densities.d2t2, densities.d2t8, densities.d8t2, densities.d8t8) {
par(mfcol=c(2,2))
par(mar=c(4,5,2,0)+.1)
plot(densities.d2t2, type="h", lwd=5, xlim=c(0,3), ylim=c(0,max(densities.d2t2)*1.1), 
         xlab="", ylab="Probability")
plot(densities.d2t8, type="h", lwd=5, xlim=c(0,9), ylim=c(0,max(densities.d2t8)*1.1), 
         xlab="Hybridization count", ylab="Probability")
par(mar=c(4,3,2,2)+.1)
plot(densities.d8t2, type="h", lwd=5, xlim=c(0,3), ylim=c(0,max(densities.d8t2)*1.1), 
         xlab="", ylab="")
plot(densities.d8t8, type="h", lwd=5, xlim=c(0,9), ylim=c(0,max(densities.d8t8)*1.1), 
         xlab="Hybridization count", ylab="")
}

drawgraphs(xnh, densities.d2t2, densities.d2t8, densities.d8t2, densities.d8t8)




postscript(file = "C:/Users/Graham/AAA/Docs/PCTeX/GoteborgDT/Article/priorestimate.eps",
           width=3, height=3, pointsize=8, horizontal=FALSE,
           paper="special")
drawgraphs(xnh, densities.d2t2, densities.d2t8, densities.d8t2, densities.d8t8)
dev.off() 











