

setwd("C:/Users/Work/AAA/Programming/Goteborg/AlloppRcode-nhybs")
source("AlloppDT_1readconfig.r")
source("Analysis_rfd_nex2treestring.r")
source("Analysis_rfd_nodetable2trlb.r")
source("Analysis_rfd_calc.r")



glue <- function(...) {
  paste(..., sep="")
}




config.index.from.GNT <- function(config, G, N, T) {
      ii <- -1
    for (i in 1:length(config$configG)) {
      if (config$configG[i] == G  &&  config$configN[i] == N  &&  
          abs(config$configT[i] - T) < config$configT[i]*1e-8) {
        stopifnot(ii<0)
        ii <- i
      }
    }
    stopifnot(ii > 0)
    ii
}



rfd.onescenario.oneG.oneN <- function(dpath, G, N, Ts) {
  nT <- length(Ts)
  config <- read.config(dpath)  
  ii <- config.index.from.GNT(config, G, N, Ts[1])
  nreps <- config$configR[ii]
  rfd.results <- matrix(-1, nrow=nT, ncol=nreps)
  rfdmiss.results <- matrix(-1, nrow=nT, ncol=nreps)
  rfdtop.results <- matrix(-1, nrow=nT, ncol=nreps)
  
  for (Ti in 1:nT) {
    ii <- config.index.from.GNT(config, G, N, Ts[Ti])
    trueMtree.fpath <- fpath.multree(config, ii)
    trueMtree.trlbi <- nodetable.to.trlbi(trueMtree.fpath)
    trueMtree.trlbi <- remove.seqchars(trueMtree.trlbi, "A", "B")
    trueMtree.tetpairs <- find.tet.pairs(trueMtree.trlbi)
    trueMtree.trlbi <- add.seqchars(trueMtree.trlbi, trueMtree.tetpairs, "A", "B")
    trueMtree.clades <- trlbi.to.clades(trueMtree.trlbi)
    
    stopifnot(nreps == config$configR[ii]) # reps vary with T
    for (r in 1:nreps) {
      concensusMtree.fpath <- fpath.mccmultree(config, ii, r)
      concensusMtree <- tree.string.from.nexus(concensusMtree.fpath)               
      concensusMtree.trlbi.tetpairs <- newick.string.to.trlbi.and.tetpairs(concensusMtree, "0", "1")
      concensusMtree.trlbi <- concensusMtree.trlbi.tetpairs$trlbi
      concensusMtree.tetpairs <- concensusMtree.trlbi.tetpairs$tetpairs
      rfd <- multree.rfd(trueMtree.clades, concensusMtree.trlbi, concensusMtree.tetpairs)
      rfd.results[Ti, r] <- rfd$rfd
      rfdmiss.results[Ti, r] <- rfd$rfdmiss
      rfdtop.results[Ti, r] <- rfd$rfdtop
    }
  }
  list(rfd=rfd.results, rfdmiss=rfdmiss.results, rfdtop=rfdtop.results)
 }
 
 



do.ABC.oneG.oneN <- function(G, N, Ts) {
A.res <- rfd.onescenario.oneG.oneN(glue(basedpath, "A"), G, N, Ts)
B.res <- rfd.onescenario.oneG.oneN(glue(basedpath, "B"), G, N, Ts)
C.res <- rfd.onescenario.oneG.oneN(glue(basedpath, "C"), G, N, Ts)
ABC.rfd <- cbind(A.res$rfd, B.res$rfd, C.res$rfd)
ABC.rfdmiss <- cbind(A.res$rfdmiss, B.res$rfdmiss, C.res$rfdmiss)
ABC.rfdtop <- cbind(A.res$rfdtop, B.res$rfdtop, C.res$rfdtop)
list(rfd=ABC.rfd, rfdmiss=ABC.rfdmiss, rfdtop=ABC.rfdtop)
}



do.DEF.oneG.oneN <- function(G, N, Ts) {
D.res <- rfd.onescenario.oneG.oneN(glue(basedpath, "D"), G, N, Ts)
E.res <- rfd.onescenario.oneG.oneN(glue(basedpath, "E"), G, N, Ts)
F.res <- rfd.onescenario.oneG.oneN(glue(basedpath, "F"), G, N, Ts)
DEF.rfd <- cbind(D.res$rfd, E.res$rfd, F.res$rfd)
DEF.rfdmiss <- cbind(D.res$rfdmiss, E.res$rfdmiss, F.res$rfdmiss)
DEF.rfdtop <- cbind(D.res$rfdtop, E.res$rfdtop, F.res$rfdtop)
list(rfd=DEF.rfd, rfdmiss=DEF.rfdmiss, rfdtop=DEF.rfdtop)
}





plot.oneG.oneN.oneHeight <- function(x.GN, gg, nn, ymax, do.yaxt) {
  nams <- c("H", "M", "L")
  yaxt <- "n"
  if (do.yaxt) { 
    yaxt <- "s" 
    par(mar=c(4,4,1,0.5))
  } else {
    yaxt <- "n" 
    par(mar=c(4,0.5,1,0.5))
    }
  boxplot(x=x.GN, ylim=c(0,ymax), names=nams, yaxt=yaxt, las=1, boxfill="grey", boxwex=0.6)
  text(2, 0.95*ymax, paste(gg, nn))
}




###########################################################################
#This for main A,B,C,D,E,F scenarios

Ts <- c(4e-9, 2e-8, 1e-7)

basedpath <- "I:/2016-03-25-AlloppNET-output/"


DEF.G1 <- NULL
DEF.G1 <- c(DEF.G1, list(N1=do.DEF.oneG.oneN(1,1,Ts)))
DEF.G1 <- c(DEF.G1, list(N3=do.DEF.oneG.oneN(1,3,Ts)))
DEF.G1 <- c(DEF.G1, list(N9=do.DEF.oneG.oneN(1,9,Ts)))
DEF.G3 <- NULL
DEF.G3 <- c(DEF.G3, list(N1=do.DEF.oneG.oneN(3,1,Ts)))
DEF.G3 <- c(DEF.G3, list(N3=do.DEF.oneG.oneN(3,3,Ts)))
DEF.G3 <- c(DEF.G3, list(N9=do.DEF.oneG.oneN(3,9,Ts)))
DEF.G9 <- NULL
DEF.G9 <- c(DEF.G9, list(N1=do.DEF.oneG.oneN(9,1,Ts)))
DEF.G9 <- c(DEF.G9, list(N3=do.DEF.oneG.oneN(9,3,Ts)))
DEF.G9 <- c(DEF.G9, list(N9=do.DEF.oneG.oneN(9,9,Ts)))
DEF <- NULL
DEF <- c(DEF, list(G1=DEF.G1))
DEF <- c(DEF, list(G3=DEF.G3))
DEF <- c(DEF, list(G9=DEF.G9))
DEF.rdf <- NULL
for (gg in c("G1", "G3", "G9")) {
  for (nn in c("N1", "N3", "N9")) {
    for (i in 3:1) {  DEF.rdf[[gg]][[nn]] <- c(DEF.rdf[[gg]][[nn]], list(DEF[[gg]][[nn]][["rfd"]][i,])) }
  }
}
DEF.rdftop <- NULL
for (gg in c("G1", "G3", "G9")) {
  for (nn in c("N1", "N3", "N9")) {
    for (i in 3:1) {  DEF.rdftop[[gg]][[nn]] <- c(DEF.rdftop[[gg]][[nn]], list(DEF[[gg]][[nn]][["rfdtop"]][i,])) }
  }
}



mat <- matrix(1:9, nrow=3, ncol=3)
layout(mat=mat, widths=c(1,1,1))


for (gg in c("G1", "G3", "G9")) {
  for (nn in c("N1", "N3", "N9")) {
    plot.oneG.oneN.oneHeight(DEF.rdftop[[gg]][[nn]], gg, nn, 15, TRUE)
  }
}



for (gg in c("G1", "G3", "G9")) {
  for (nn in c("N1", "N3", "N9")) {
    plot.oneG.oneN.oneHeight(DEF.rdf[[gg]][[nn]], gg, nn, 0.20, TRUE)
  }
}



#############################################################################
# This for scenario J with 6dips 7tets.

# 
# Ts <- c(2e-8)
# 
# basedpath <- "I:/2016-03-25-AlloppNET-output/"
# JKL.res <- NULL
# JKL.res <- c(JKL.res, list(G1N1=rfd.onescenario.oneG.oneN(glue(basedpath, "J"), 1, 1, Ts)))
# JKL.res <- c(JKL.res, list(G1N3=rfd.onescenario.oneG.oneN(glue(basedpath, "J"), 1, 3, Ts)))
# JKL.res <- c(JKL.res, list(G3N1=rfd.onescenario.oneG.oneN(glue(basedpath, "J"), 3, 1, Ts)))
# JKL.res <- c(JKL.res, list(G3N3=rfd.onescenario.oneG.oneN(glue(basedpath, "J"), 3, 3, Ts)))
# JKL.res <- c(JKL.res, list(G9N1=rfd.onescenario.oneG.oneN(glue(basedpath, "J"), 9, 1, Ts)))
# JKL.res <- c(JKL.res, list(G9N3=rfd.onescenario.oneG.oneN(glue(basedpath, "L"), 9, 3, Ts)))
# 
# GNnames <- c("G1N1", "G1N3", "G3N1", "G3N3", "G9N1", "G9N3")
# JKL.rfd <- NULL 
# JKL.rfdmiss <- NULL 
# JKL.rfdtop <- NULL 
# for (ggnn in GNnames) {
#   JKL.rfd <- c(JKL.rfd, list(JKL.res[[ggnn]][["rfd"]][1,]))
#   JKL.rfdmiss <- c(JKL.rfdmiss, list(JKL.res[[ggnn]][["rfdmiss"]][1,]))
#   JKL.rfdtop <- c(JKL.rfdtop, list(JKL.res[[ggnn]][["rfdtop"]][1,]))
# }
# names(JKL.rfd) <- GNnames 
# names(JKL.rfdmiss) <- GNnames 
# names(JKL.rfdtop) <- GNnames 
# mat <- matrix(c(1,2), nrow=3, ncol=1)
# #layout(mat=mat)
# par(mar=c(10,6,1,1)+0.1)
# boxplot(x=JKL.rfd, ylim=c(0,0.21), las=2, boxfill="grey", boxwex=0.6)
# #boxplot(x=JKL.rfdtop, ylim=c(0,9), las=2, boxfill="grey", boxwex=0.6)
# 









